# std::tr1::linear_congruential< _UIntType, __a, __c, __m > Class Template Reference
[Random Number Generators]

List of all members.

## Detailed Description

### template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
class std::tr1::linear_congruential< _UIntType, __a, __c, __m >

A random number generator that produces pseudorandom numbers using the linear function .

The template parameter `_UIntType` must be an unsigned integral type large enough to store values up to (__m-1). If the template parameter `__m` is 0, the modulus `__m` used is std::numeric_limits<_UIntType>::max() plus 1. Otherwise, the template parameters `__a` and `__c` must be less than `__m`.

The size of the state is .

Definition at line 297 of file random.

## Public Types

- typedef _UIntType result_type

## Public Member Functions

- template<class _Gen> linear_congruential (_Gen &__g)
- linear_congruential (unsigned long __x0=1)
- result_type max () const
- result_type min () const
- result_type operator() ()
- template<class _Gen> void seed (_Gen &__g)
- void seed (unsigned long __s=1)

## Static Public Attributes

- static const _UIntType increment
- static const _UIntType modulus
- static const _UIntType multiplier

## Friends

- bool operator!= (const linear_congruential &__lhs, const linear_congruential &__rhs)
- template<class _UIntType1, _UIntType1 __a1, _UIntType1 __c1, _UIntType1 __m1, typename _CharT, typename _Traits> std::basic_ostream< _CharT,
  _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > &__os, const linear_congruential< _UIntType1, __a1, __c1, __m1 > &__lcr)
- bool operator== (const linear_congruential &__lhs, const linear_congruential &__rhs)
- template<class _UIntType1, _UIntType1 __a1, _UIntType1 __c1, _UIntType1 __m1, typename _CharT, typename _Traits> std::basic_istream< _CharT,
  _Traits > & operator>> (std::basic_istream< _CharT, _Traits > &__is, linear_congruential< _UIntType1, __a1, __c1, __m1 > &__lcr)

## Member Typedef Documentation

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

typedef _UIntType std::tr1::linear_congruential< _UIntType, __a, __c, __m >::result_type

The type of the generated random value.

Definition at line 304 of file random.

## Constructor & Destructor Documentation

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

std::tr1::linear_congruential< _UIntType, __a, __c, __m >::linear_congruential | ( | unsigned long | __x0 = `1` | ) | `[inline, explicit]`

Constructs a linear_congruential random number generator engine with seed `__s`. The default seed value is 1.

Parameters:

  | __s | The initial seed value.

Definition at line 320 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
template<class _Gen>

std::tr1::linear_congruential< _UIntType, __a, __c, __m >::linear_congruential | ( | _Gen & | __g | ) | `[inline]`

Constructs a linear_congruential random number generator engine seeded from the generator function `__g`.

Parameters:

  | __g | The seed generator function.

Definition at line 330 of file random.

## Member Function Documentation

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

result_type std::tr1::linear_congruential< _UIntType, __a, __c, __m >::max | ( |  | ) | const`[inline]`

Gets the largest possible value in the output range.

Definition at line 367 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

result_type std::tr1::linear_congruential< _UIntType, __a, __c, __m >::min | ( |  | ) | const`[inline]`

Gets the smallest possible value in the output range.

The minumum depends on the `__c` parameter: if it is zero, the minimum generated must be > 0, otherwise 0 is allowed.

Definition at line 360 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

linear_congruential< _UIntType, __a, __c, __m >::result_type std::tr1::linear_congruential< _UIntType, __a, __c, __m >::operator() | ( |  | ) |

Gets the next random number in the sequence.

Definition at line 134 of file random.tcc.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
template<class _Gen>

void std::tr1::linear_congruential< _UIntType, __a, __c, __m >::seed | ( | _Gen & | __g | ) | `[inline]`

Reseeds the linear_congruential random number generator engine sequence using values from the generator function `__g`.

Parameters:

  | __g | the seed generator function.

Definition at line 350 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

void std::tr1::linear_congruential< _UIntType, __a, __c, __m >::seed | ( | unsigned long | __s = `1` | ) |

Reseeds the linear_congruential random number generator engine sequence to the seed __s.

Parameters:

  | __s | The new seed.

Definition at line 102 of file random.tcc.

## Friends And Related Function Documentation

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

bool operator!= | ( | const linear_congruential< _UIntType, __a, __c, __m > & | __lhs,
|  | const linear_congruential< _UIntType, __a, __c, __m > & | __rhs |
| ) |  |  | `[friend]`

Compares two linear congruential random number generator objects of the same type for inequality.

Parameters:

  | __lhs | A linear congruential random number generator object.
  | __rhs | Another linear congruential random number generator obj.

Returns:
  true if the two objects are not equal, false otherwise.

Definition at line 400 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
template<class _UIntType1, _UIntType1 __a1, _UIntType1 __c1, _UIntType1 __m1, typename _CharT, typename _Traits>

std::basic_ostream<_CharT, _Traits>& operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const linear_congruential< _UIntType1, __a1, __c1, __m1 > & | __lcr |
| ) |  |  | `[friend]`

Writes the textual representation of the state x(i) of x to `__os`.

Parameters:

  | __os | The output stream.
  | __lcr | A % linear_congruential random number generator.

Returns:
  __os.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

bool operator== | ( | const linear_congruential< _UIntType, __a, __c, __m > & | __lhs,
|  | const linear_congruential< _UIntType, __a, __c, __m > & | __rhs |
| ) |  |  | `[friend]`

Compares two linear congruential random number generator objects of the same type for equality.

Parameters:

  | __lhs | A linear congruential random number generator object.
  | __rhs | Another linear congruential random number generator obj.

Returns:
  true if the two objects are equal, false otherwise.

Definition at line 386 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
template<class _UIntType1, _UIntType1 __a1, _UIntType1 __c1, _UIntType1 __m1, typename _CharT, typename _Traits>

std::basic_istream<_CharT, _Traits>& operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | linear_congruential< _UIntType1, __a1, __c1, __m1 > & | __lcr |
| ) |  |  | `[friend]`

Sets the state of the engine by reading its textual representation from `__is`.

The textual representation must have been previously written using an output stream whose imbued locale and whose type's template specialization arguments _CharT and _Traits were the same as those of `__is`.

Parameters:

  | __is | The input stream.
  | __lcr | A % linear_congruential random number generator.

Returns:
  __is.

## Member Data Documentation

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

const _UIntType std::tr1::linear_congruential< _UIntType, __a, __c, __m >::increment`[static]`

An increment.

Definition at line 309 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

const _UIntType std::tr1::linear_congruential< _UIntType, __a, __c, __m >::modulus`[static]`

The modulus.

Definition at line 311 of file random.

template<class _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>

const _UIntType std::tr1::linear_congruential< _UIntType, __a, __c, __m >::multiplier`[static]`

The multiplier.

Definition at line 307 of file random.

The documentation for this class was generated from the following files:

- random
- random.tcc